<?php
/**
 * Displays a given autodoc file.
 * @package PHP-AutoDocViewer
 * @author Sascha 'SieGeL' Pfalz <php@saschapfalz.de>
 * @version 0.3 (15-Aug-2008)
 * $Id: show_adoc.php,v 1.3 2008/08/16 11:18:21 siegel Exp $
 * @filesource
 */
/**
 */
require_once("inc/nocache.php");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
<title>PHP-AutoDocViewer v<?php echo(VER);?> by Sascha 'SieGeL' Pfalz</title>
<meta http-equiv="content-type" content="text/html; charset=iso-8859-1">
<meta http-equiv="Expires" content="<?php echo(date('r'));?>">
<meta http-equiv="Cache-control" content="no-cache">
<meta http-equiv="pragma" content="no-cache">
<meta name="author" content="Sascha 'SieGeL' Pfalz <php@saschapfalz.de>">
<meta name="distribution" content="Local">
<meta name="revisit-after" content="0 days">
<meta name="copyright" content="Sascha 'SieGeL' Pfalz <php@saschapfalz.de>">
<meta name="description" content="PHP Script to read the Amiga AutoDocs in a browser">
<meta name="keywords" content="Amiga, AutoDocs, Development, PHP">
<meta name="date" content="<?php echo(date ("r", getlastmod()));?>">
<link rel="stylesheet" type="text/css" href="inc/adoc_style.css">
</head>
<body>
<?php
$adocfile = @strip_tags($_GET['FILE']);
if($adocfile == '')
  {
  echo("<p class=\"error\">ERROR: Filename is empty!</p>");
  echo("<a href=\"index.php\">Back to index page</a>\n");
  echo("</body>\n</html>\n");
  exit;
  }
$adocfile = ADOCDIR.'/'.basename($adocfile);
$adocsize = @filesize($adocfile);
if(!$adocsize)
  {
  echo("<p class=\"error\">ERROR: Got a file size of 0 ??? Something must be wrong here!</p>\n");
  echo("<a href=\"index.php\">Back to index page</a>\n");
  echo("</body>\n</html>\n");
  exit;
  }
?>
<table cellspacing="0" cellpadding="0" border="0" width="100%" summary="header">
<tr>
  <td align="left"><b>Viewing <?php echo(preg_replace("/.doc$/","",basename($adocfile))." (".number_format($adocsize)." bytes)");?></b></td>
  <td align="right"><a href="index.php">&lt;&lt;&nbsp;Back</a></td>
</tr>
<tr>
  <td colspan="2"><hr></td>
</tr>
</table>
<?php
@flush();
$afile = file($adocfile);

/*
 *  Perform some sanity checks. First the TABLE OF CONTENTS header must exist, second the
 *  file must contain "page-breaks" to indicate the different sections. If one of them
 *  is not found we skip parsing and display the file as-is.
 */

$found = 0;
if(!StrStr($afile[0],"TABLE OF CONTENTS"))
  {
  echo("<p class=\"error\">WARNING: File ".$adocfile." has no valid header!</p>\n");
  }
else
  {
  for($i = 0; $i < count($afile); $i++)
    {
    if($afile[$i][0] == '')
      {
      $found = 1;
      break;
      }
    }
  }
if(!$found)
  {
  echo("<p class=\"error\">WARNING: File ".$adocfile." has no valid format, dumping out without parsing!</p>\n<hr>\n");
  echo("</pre>\n");
  readfile($adocfile);
  echo("<hr>\n</pre>\n</body>\n</html>\n");
  exit;
  }
$linecount = 1;       // We skip the header
$functions = array();
$resource  = "";
while($afile[$linecount][0] != '')
  {
  $line = trim($afile[$linecount]);
  if($line == '')
    {
    $linecount++;
    continue;
    }
  array_push($functions,$line);
  $linecount++;
  }
$resource = preg_replace("/(.*?)(\/)(.*)/","$1",$functions[0]);
?>
<b><?php echo($resource);?></b> defines <b><?php echo(count($functions));?></b> functions<br>
<br>
<table cellspacing="0" cellpadding="0" border="0" width="98%" summary="List of defined functions">
<tr>
<?php
for($i = 0; $i < count($functions); $i++)
  {
  if(!($i % FUNC_ENTRIES) && $i)
    {
    echo("</tr>\n<tr>\n");
    }
  $funcname = trim(preg_replace("/(.*?)(\/)(.*)/","$3",$functions[$i]));
  echo("  <td><a href=\"#".$funcname."\">".$funcname."</a></td>\n");
  }
if(($i % FUNC_ENTRIES) && $i)
  {
  echo("  <td colspan=\"".(FUNC_ENTRIES-($i % FUNC_ENTRIES))."\">&nbsp;</td>\n");
  }
?>
</tr>
</table>
<br>
<hr>
<pre>
<?php
$flistcnt = 0;
while($linecount < count($afile))
  {
  if($afile[$linecount][0]=='')
    {
    $testname = trim(preg_replace("/(.*?)(\s+.*)/","$2",trim(substr($afile[$linecount],1))));
    if(in_array($testname,$functions)==true)
      {
      if($flistcnt)
        {
        echo("</pre>\n<hr>\n<pre>\n");
        }
      $funcname = basename($testname);
      echo("<a name=\"".$funcname."\">".substr($afile[$linecount],1)."</a>");
      $flistcnt++;
      }
    else
      {
      echo(substr($afile[$linecount],1));
      }
    }
  else
    {
    echo(htmlentities($afile[$linecount]));
    }
  $linecount++;
  }
?>
</pre>
<hr>
<a href="index.php">&lt;&lt;&nbsp;Back</a><br>
<br>
</body>
</html>
